/*
 * DataBean.java
 *
 * Created on 30 settembre 2007, 23.18
 *
 */

package it.jplasmide.doctool;

/**
 *
 * @author Dario Lucia
 */
public class DataBean implements Comparable<DataBean> {
    
    private String name;
    private String description;
    private String prePostConditions;
    private String example;
    
    /** Creates a new instance of DataBean */
    public DataBean(String name, String description, String prePostConditions,String example) {
        this.name = name;
        this.description = description;
        this.prePostConditions = prePostConditions;
        this.example = example;
    }

    public String toHTMLString() {
        return "<p><b><font size=\"5\">" + name.replaceAll("<","&lt;").replaceAll(">","&gt;") + "</font></b><br/>" + description.replaceAll("<","&lt;").replaceAll(">","&gt;") + "<br /><b>Pre/Post Conditions: </b>" + prePostConditions.replaceAll("<","&lt;").replaceAll(">","&gt;") +"<br /><b>Example: </b>" + example.replaceAll("<","&lt;").replaceAll(">","&gt;") + "</p>";
    }
    
    public String getName() {
        return name;
    }

    public String getDescription() {
        return description;
    }
    
    public String getPrePostConditions() {
        return prePostConditions;
    }

    public String getExample() {
        return example;
    }

    public int compareTo(DataBean o) {
        return this.getName().compareTo(o.getName());
    }
    
    public boolean equals(Object o) {
        DataBean b = (DataBean) o;
        return this.getName().equals(b.getName());
    }

    public int hashCode() {
        return this.name.hashCode();
    }
    
    
    
}
