/*
 * DataBeanContainer.java
 *
 * Created on 30 settembre 2007, 23.48
 *
 */

package it.jplasmide.doctool;

import java.util.Collection;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

/**
 *
 * @author dario
 */
public class DataBeanContainer {
    
    private Set<DataBean> beans;
    
    /** Creates a new instance of DataBeanContainer */
    public DataBeanContainer() {
        this.beans = new TreeSet<DataBean>();
    }
    
    public void addBean(DataBean b) {
        this.beans.add(b);
    }
    
    public void addAllBeans(Collection<DataBean> beans) {
        this.beans.addAll(beans);
    }
    
    public DataBean getBeanByName(String name) {
        for(DataBean b : this.beans)
            if (b.getName().equals(name)) return b;
        return null;
    }
    
    public List<DataBean> getBeans(String nameSubstring) {
        List<DataBean> lista = new LinkedList<DataBean>();
        if(nameSubstring.equals("")) {
            lista.addAll(this.beans);
        } else {
            
            String cmd = nameSubstring.toLowerCase();
            for(DataBean b : this.beans) {
                if(b.getName().toLowerCase().indexOf(cmd) != -1)
                    lista.add(b);
            }
        }
        return lista;
    }
}
