/*
 * XMLProcess.java
 *
 * Created on 6 ottobre 2007, 9.30
 *
 */

package it.jplasmide.doctool;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.Collections;
import java.util.Set;
import java.util.TreeSet;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author dario
 */
public class XMLProcessor implements DocumentFileProcessor {
    
    
    public Set<DataBean> processDocSource(URL file) {
        
        try {
            
            Document doc = null;
            try {
                // Create a builder factory
                DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
                factory.setValidating(false);
    
                // Create the builder and parse the file
                doc = factory.newDocumentBuilder().parse(file.toString());
                
            } catch (SAXException e) {
                e.printStackTrace();
                return Collections.emptySet();
            } catch (ParserConfigurationException e) {
                e.printStackTrace();
                return Collections.emptySet();
            } catch (IOException e) {
                e.printStackTrace();
                return Collections.emptySet();
            }
                       
            String xpathexp = "//p";
            System.out.println("");
            XPathFactory xpathfactory = XPathFactory.newInstance();
            XPath xpath = xpathfactory.newXPath();
            XPathExpression expr;
            expr = xpath.compile(xpathexp);
            System.out.println("");
            // Get the matching elements
            NodeList nodelist = (NodeList) expr.evaluate(doc, XPathConstants.NODESET);
            System.out.println("");
            DataBeanFactory ff = new DataBeanFactory();
            Set<DataBean> dbc = new TreeSet<DataBean>();

            // Process the elements in the nodelist
            for (int i=0; i<nodelist.getLength(); i++) {
                // Get element
                Element elem = (Element) nodelist.item(i);
                DataBean db = ff.parseDataBean(elem);
                if(db != null && db.getName() != null && !db.getName().trim().equals(""))
                    dbc.add(db);
            }
            
            nodelist = null;
            doc = null;
           
            Runtime.getRuntime().gc();
            
            return dbc;
       
        } catch (XPathExpressionException ex) {
            ex.printStackTrace();
        }
        
        return Collections.emptySet();
    }
    
}
