/*
 * NotifyDataTextChangeListener.java
 *
 * Created on 8 ottobre 2007, 19.52
 *
 */

package it.jplasmide.gui.listeners;

import it.jplasmide.gui.utils.PlasmPane;
import java.awt.Color;
import javax.swing.JTabbedPane;
import javax.swing.JTextPane;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.BadLocationException;
import javax.swing.text.DefaultHighlighter;
import javax.swing.text.Document;
import javax.swing.text.Highlighter;
import javax.swing.text.JTextComponent;

/**
 *
 * @author dario
 */
public class NotifyDataTextChangeListener implements DocumentListener{
    
    /* Important language words */
    private String[] highlightWords = new String[] {"DEF","WHERE","END","VIEW"};
    
    private JTextPane jta;
    private JTabbedPane container;
    
    /** Creates a new instance of NotifyDataTextChangeListener */
    public NotifyDataTextChangeListener(JTextPane jta, JTabbedPane container) {
        this.jta = jta;
        this.container = container;
    }

     public void changedUpdate(DocumentEvent documentEvent) {
         
//        removeHighlights(jta);
//
//       for(String s : highlightWords)
//           highlight(jta,s);
         
        /* Signaling */
        PlasmPane p = (PlasmPane) (jta.getParent().getParent());
        p.getData().setModified(true);

        notifyDataTabChanges(p);
    }
     
     
    public void insertUpdate(DocumentEvent documentEvent) {
        
//        removeHighlights(jta);
//
//       for(String s : highlightWords)
//           highlight(jta,s);
        
        /* Signaling */
        PlasmPane p = (PlasmPane) (jta.getParent().getParent());
        p.getData().setModified(true);

        notifyDataTabChanges(p);
    }
            
            
    public void removeUpdate(DocumentEvent documentEvent) {
     
//        removeHighlights(jta);
//
//        for(String s : highlightWords)
//           highlight(jta,s);
      
        /* Signaling */
        PlasmPane p = (PlasmPane) (jta.getParent().getParent());
        p.getData().setModified(true);

        notifyDataTabChanges(p);
    }
    
    private void notifyDataTabChanges(PlasmPane selPanel) {
        /* Check title */
       int indOfC = this.container.indexOfComponent(selPanel);
       if(indOfC >= 0) {
            if(selPanel.getData().isModified()) {
                this.container.setTitleAt(indOfC,selPanel.getData().getFilename() + " (*)");
            } else {
                this.container.setTitleAt(indOfC,selPanel.getData().getFilename());
            }
       
       }    
    }
    
}
