/*
 * BackupManager.java
 *
 * Created on 10 ottobre 2007, 21.34
 *
 */

package it.jplasmide.gui.utils;

import java.awt.Component;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import javax.swing.JOptionPane;
import javax.swing.JTabbedPane;

/**
 *
 * @author dario
 */
public class BackupManager extends Thread {
    
    private int seconds;
    private JTabbedPane docPanel;

    private boolean isRunning;
    
    /** Creates a new instance of BackupManager */
    public BackupManager(int seconds, JTabbedPane docPanel) {
        this.seconds = seconds;
        this.docPanel = docPanel;
        this.isRunning = false;
    }
    
    public void run() {
        this.isRunning = true;
        while(isRunning) {
            try {
                /* Sleeping */
                Thread.sleep(seconds * 1000);
                for(Component c : this.docPanel.getComponents()) {
                   PlasmPane p = (PlasmPane) c;
                   makeBackup(p);
                }

            } catch (InterruptedException e) {
                System.out.println("Exiting from backup thread");
                this.isRunning = false;
            }
        }
    }
    
    private void makeBackup(PlasmPane selPanel) {
        if(selPanel != null) {
            if(selPanel.getData().getPath() != null) {
                try {
                    saveFile(selPanel.getData().getPath(), selPanel);
                } catch (Exception e) {
                    e.printStackTrace();
                }                
            }
        }
    }

    private void saveFile(String filepath, PlasmPane selPanel) {
        
        File f = new File(filepath + "~");
        try {
            /* Create file */
            if(!f.exists())
                f.createNewFile();

            /* Write tab to file */
            FileWriter fw = new FileWriter(f);
            BufferedWriter bw = new BufferedWriter(fw);
            bw.write(selPanel.getJSyntaxTextPane().getText());
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    
}
