/*
 * PlasmTab.java
 *
 * Created on 29 settembre 2007, 23.09
 *
 */

package it.jplasmide.gui.utils;

import javax.swing.Action;
import javax.swing.JComponent;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.event.UndoableEditEvent;
import javax.swing.event.UndoableEditListener;
import javax.swing.text.DefaultEditorKit;
import javax.swing.undo.CannotUndoException;
import javax.swing.undo.UndoManager;
import jsyntax.JSyntaxTextPane;

/**
 *
 * @author Dario Lucia
 */
public class PlasmPane extends JScrollPane {
    
    private FileMetadata data;
    private JComponent jcomponent;
    
    /** Creates a new instance of PlasmTab */
    public PlasmPane() {
        this.setData(new FileMetadata());
        this.setJcomponent(null);
    }

    public PlasmPane(JComponent a) {
        super(a);
        this.setData(new FileMetadata());
        this.setJcomponent(a);
    }
    
    public FileMetadata getData() {
        return data;
    }

    public void setData(FileMetadata data) {
        this.data = data;
    }

    public JComponent getJcomponent() {
        return jcomponent;
    }

    public void setJcomponent(JComponent jcomponent) {
        this.jcomponent = jcomponent;
    }
    
    public JSyntaxTextPane getJSyntaxTextPane() {
        return (JSyntaxTextPane) getJcomponent();
    }
    
    public void performUndo() {
        try {
           getJSyntaxTextPane().undo();
        } catch (CannotUndoException e) {
            e.printStackTrace();
        }
    }
    
    public void performRedo() {
        try {
           getJSyntaxTextPane().redo();
        } catch (CannotUndoException e) {
            e.printStackTrace();
        }
    }
    
    public void performCopy(java.awt.event.ActionEvent evt) {
        JTextPane txa = this.getJSyntaxTextPane();
        Action actions[] = txa.getActions();
        Action copyAction = TextUtilities.findAction(actions,DefaultEditorKit.copyAction);
        copyAction.actionPerformed(evt);
    }
    
    public void performCut(java.awt.event.ActionEvent evt) {
        JTextPane txa = this.getJSyntaxTextPane();
        Action actions[] = txa.getActions();
        Action cutAction = TextUtilities.findAction(actions,DefaultEditorKit.cutAction);
        cutAction.actionPerformed(evt);
    }
    
    public void performPaste(java.awt.event.ActionEvent evt) {
        JTextPane txa = this.getJSyntaxTextPane();
        Action actions[] = txa.getActions();
        Action pasteAction = TextUtilities.findAction(actions,DefaultEditorKit.pasteAction);
        pasteAction.actionPerformed(evt);
    }
    
}
